//
// Created by nicolas on 22/03/18.
//

#include <stdint.h>
#include <stddef.h>
#include <stdio.h>
#include "position.h"
#include "utils/debug.h"

esc_position_t* esc_position_create(int64_t prepare_position, int64_t commit_position) {
    esc_position_t* res = malloc(sizeof(struct st_esc_position));
    res->prepare_position = prepare_position;
    res->commit_position = commit_position;
    return res;
}

inline void esc_position_destroy(esc_position_t* pos) {
    free(pos);
}

int esc_position_compare(esc_position_t* left, esc_position_t* right) {
    if ((left->commit_position < right->commit_position) || ((left->commit_position == right->commit_position) && (left->prepare_position < right->prepare_position)))
        return -1;
    if ((left->commit_position > right->commit_position) || ((left->commit_position == right->commit_position) && (left->prepare_position > right->prepare_position)))
        return 1;
    return 0;
}

const char* esc_position_format(esc_position_t* position, char* buffer, size_t buf_size) {
#ifdef _WIN32
    snprintf(buffer, buf_size, "%llu/%llu", position->prepare_position, position->commit_position);
#else
    snprintf(buffer, buf_size, "%lu/%lu", position->prepare_position, position->commit_position);
#endif
    return buffer;
}
