//
// Created by nicolas on 22/03/18.
//

#include "utils/debug.h"
#include "position.h"
#include "results.h"

void esc_recorded_event_destroy(esc_recorded_event_t* recorded_event) {
    uuid_destroy(recorded_event->event_id);
    free((void*)recorded_event->event_type);
    free((void*)recorded_event->event_stream_id);
    buffer_destroy(recorded_event->data);
    buffer_destroy(recorded_event->metadata);
    free(recorded_event);
}

void esc_resolved_event_destroy(esc_resolved_event_t* resolved_event) {
    if (resolved_event->original_position) esc_position_destroy(resolved_event->original_position);
    if (resolved_event->event) esc_recorded_event_destroy(resolved_event->event);
    if (resolved_event->link) esc_recorded_event_destroy(resolved_event->link);
    free(resolved_event);
}


void esc_all_events_slice_destroy(esc_all_events_slice_t* all_events_slice) {
    esc_position_destroy(all_events_slice->from_position);
    esc_position_destroy(all_events_slice->next_position);
    for (size_t i = 0; i < all_events_slice->n_events; i++) {
        esc_resolved_event_destroy(all_events_slice->events[i]);
    }
    free(all_events_slice->events);
    free(all_events_slice);
}

void esc_write_result_destroy(esc_write_result_t* write_result) {
    esc_position_destroy(write_result->log_position);
    free(write_result);
}
